      SUBROUTINE BSTPAR9Z( NAME, M, N, NPROCS, AMEM, MEMSIZE,
     $                    NBMIN, NBMAX, DNB, NPRWMIN, NPRWMAX, DNPRW,
     $                    INFILEA, INFILEB, OUTFILE, TFILE, NPRT )
*
      include 'mpif.h'
*
      INTEGER         MEMSIZE, DNB, DNPRW, M, N, NPROCS,
     $                NPRWMAX, NPRWMIN, NBMIN, NBMAX, NPRT
*
      DOUBLE COMPLEX  AMEM( MEMSIZE )
*
      CHARACTER       NAM*9
      CHARACTER*(*)   TRANS, NAME, UPLO
      CHARACTER       NLB*7, NLLB1*4, NLLB2*29, NLLB3*6
      INTEGER         NOUT, NOUT1, NPR
      PARAMETER       ( NOUT1 = 12, NOUT =13, NPR = 6, TRANS = 'N',
     $                UPLO = 'U', IBTYPE = 1 )
      CHARACTER       INFILEA*(*), INFILEB*(*), OUTFILE*(*), TFILE*(*)
*
*  
      INTEGER         CTXT, CTXTI, IAM, IAM1, INFO, J,
     $                MYCOL, MYROW, NPCOL, NPROW, IBTYPE,
     $                NPRC, NPRMAX, NPRMIN, NB, NBI,
     $                NMAX, NMIN, NBSTP, MINNB, MAXNB,
     $                MINNPRW, MAXNPRW, NPRWSTP
*
      INTEGER         NPRE, NPROWPRE, NPCOLPRE, NBPRE,
     $                NFOL, NPROWFOL, NPCOLFOL, NBFOL,
     $                NPROWI, NPCOLI, MYPROWI, MYPCOLI
*
      DOUBLE PRECISION    EPS, TPRE, TFOL, time
*
      COMMON              time, J
*
*  
*
*  
      INTEGER             BLACS_PNUM, SL_GRIDRESHAPE
      EXTERNAL            BLACS_PNUM, SL_GRIDRESHAPE
*
*  
      EXTERNAL          BLACS_EXIT, BLACS_GRIDEXIT, BLACS_GET,
     $                  BLACS_GRIDINFO, BLACS_PINFO, BLACS_GRIDINIT,
     $                  CAZ_GESVN
***     , CAZ_SYEV1N,CAZ_SYGV1N, CAZ_GESVD1N,
***     $                  CAZ_GEEV1N, CAZ_POSVN
*
*  
*
      CALL BLACS_PINFO( IAM, NPROCS1 )
*
*   ,   ,  
*   NPROCS,     ,
*        NPROCS1.
* 
      IF( NPROCS .NE. NPROCS1 ) GO TO 10
*
      J = 1
*
      NPRC = NPROCS
*
*    
*
      IF( NPRWMIN .EQ. 0 ) GO TO 1
         NPROW = NPRWMIN
         NPCOL = NPRC/NPRWMIN
         GO TO 2
*
********************************************************************
    1 CONTINUE
        NPROW = 1
        NPCOL = NPRC
*
*   BLACS'
*    
*
    2 CONTINUE
      CALL BLACS_GET( -1, 0, CTXT )
*
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
        IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9999 )
        END IF
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
*
*        
*      ( NPROW, NPCOL, NB )
*   .
*
         OPEN( NOUT1, FILE = TFILE, STATUS = 'UNKNOWN' )
*      ,
*     
*
         WRITE( NOUT1, FMT = 2007 ) NAME, N, NPRC, NBMIN, NBMAX
*
      END IF
*
*      
*
      IF( NPRT .EQ. 0 ) GO TO 12
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
        WRITE( NPR, FMT = 2007 ) NAME, N, NPRC, NBMIN, NBMAX
      END IF
*
*   
*
   12 IF( NBMIN .EQ. 0 ) GO TO 3
        MINNB = NBMIN
        MAXNB = NBMAX
        NBSTP = DNB
        GO TO 5
*
    3 CONTINUE
      MINNB = 2
      MAXNB = INT(N/2)
      NBSTP = 1
*
    5 DO 1110 NBI = MINNB, MAXNB, NBSTP
        NB = NBI
*
**      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
**        WRITE( NPR, FMT = * ) ' J =', J
**      END IF
*
      IF( NAME .EQ. 'PZGESV' ) GO TO 15
***      IF( NAME .EQ. 'PZSYEV1' ) GO TO 16
***      IF( NAME .EQ. 'PZSYGV1' ) GO TO 17
***      IF( NAME .EQ. 'PZGESVD1' ) GO TO 18
***      IF( NAME .EQ. 'PZGEEV1' ) GO TO 19
***      IF( NAME .EQ. 'PZPOSV' ) GO TO 20
*
      GO TO 10
*
   15 CALL CAZ_GESVN( NAME, TRANS, N, NPROW, NPCOL, AMEM, MEMSIZE, NB,
     $               INFILEA, INFILEB, OUTFILE, TFILE, NPRT, CTXT )
      GO TO 21
*
***   16 CALL CAZ_SYEV1N( NAME, UPLO, N, NPROW, NPCOL, AMEM, MEMSIZE, NB,
***     $                VL, VU, IL, IU, ABSTOL, INFILEA, OUTFILE,
***     $                TFILE, NPRT, CTXT)
*
***      GO TO 21
*
*    ,   
*     ,   
*      (  )
*   .
*
   21 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
        TFOL = time
        IF( TPRE .NE. 0.0D0 ) THEN
          IF( TFOL .LT. TPRE ) THEN
           TPRE = TFOL
           NBPRE = NB
           NPROWPRE = NPROW
           NPCOLPRE = NPCOL
          END IF
        ELSE
          TPRE = TFOL
          NBPRE = NB
          NPROWPRE = NPROW
          NPCOLPRE = NPCOL
        END IF
      END IF
*
*     ,   
*   
*
      IF( NPRT .EQ. 0 ) GO TO 1111
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
        WRITE( NPR, FMT = 2003 ) NPROW, NPCOL, NB, time
      END IF
*
 1111 J = J + 1
*
      IF( INFO .NE. 0 ) THEN
***
**      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
**        WRITE( NPR, FMT = * ) 'INFO =', INFO
**      END IF
***
        INFO = 0
        GO TO 1120
      END IF
*
 1110 CONTINUE
*
********************************************************************
*       
*
 1120 CONTINUE
***
**      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
**         CLOSE( NOUT1 )
**      END IF
**      STOP
***
*
      IF( NPRWMIN .EQ. 0 ) GO TO 7
       IF( NPRWMIN .EQ. NPRC ) GO TO 32
         MINNPRW = NPRWMIN + DNPRW
         MAXNPRW = NPRWMAX
         NPRWSTP = DNPRW
         GO TO 8
    7 CONTINUE
*
      NPRWSTP = 1
      MINNPRW = NPRWMIN + 1
      MAXNPRW = NPRC
*
*   
    8 DO 1114 NPRWI = MINNPRW, MAXNPRW, NPRWSTP
*
        IF( MOD(MAXNPRW, NPRWI) .NE. 0 ) GO TO 1114
        NPROW = NPRWI
        NPCOL = INT( FLOAT(NPRC)/FLOAT(NPRWI) )
*
        CTXTI = SL_GRIDRESHAPE( CTXT, 0, 1, 1, NPROW, NPCOL )
        CALL BLACS_GRIDINFO(CTXTI, NPROWI,NPCOLI, MYPROWI, MYPCOLI)
*
*   
*
      IF( NBMIN .EQ. 0 ) GO TO 9
        MINNB = NBMIN
        MAXNB = NBMAX
        NBSTP = DNB
        GO TO 11
*
    9 CONTINUE
      MINNB = 2
      MAXNB = INT(N/2)
      NBSTP = 1
*
   11 DO 1112 NBI = MINNB, MAXNB, NBSTP
        NB = NBI
*
**      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
**        WRITE( NPR, FMT = * ) ' J =', J
**      END IF
*
      IF( NAME .EQ. 'PZGESV' ) GO TO 35
***      IF( NAME .EQ. 'PZSYEV1' ) GO TO 36
***      IF( NAME .EQ. 'PZSYGV1' ) GO TO 37
***      IF( NAME .EQ. 'PZGESVD1' ) GO TO 38
***      IF( NAME .EQ. 'PZGEEV1' ) GO TO 39
***      IF( NAME .EQ. 'PZPOSV' ) GO TO 40
*
      GO TO 10
*
   35 CALL CAZ_GESVN( NAME, TRANS, N, NPROWI, NPCOLI, AMEM, MEMSIZE,
     $               NB, INFILEA,INFILEB,OUTFILE, TFILE, NPRT, CTXTI )
      GO TO 41
*
***   36 CALL CAZ_SYEV1N( NAME, UPLO, N, NPROWI, NPCOLI, AMEM, MEMSIZE,
***     $                NB, VL, VU, IL, IU, ABSTOL, INFILEA, OUTFILE,
***     $                TFILE, NPRT, CTXTI)
***      GO TO 41
*
   41 IF( MYPROWI.EQ.0 .AND. MYPCOLI.EQ.0 ) THEN
        TFOL = time
        IF( TPRE .NE. 0.0D0 ) THEN
          IF( TFOL .LT. TPRE ) THEN
           TPRE = TFOL
           NBPRE = NB
           NPROWPRE = NPROWI
           NPCOLPRE = NPCOLI
          END IF
        ELSE
          TPRE = TFOL
          NBPRE = NB
          NPROWPRE = NPROWI
          NPCOLPRE = NPCOLI
        END IF
      END IF
*
*     ,   
*   
*
        IF( NPRT .EQ. 0 ) GO TO 1115
*
        IF( MYPROWI.EQ.0 .AND. MYPCOLI.EQ.0 ) THEN
          WRITE( NPR, FMT = 2003 )NPROWI, NPCOLI, NB, time
        END IF
*
 1115   J = J + 1
*
 1112 CONTINUE
*
*    
*     BLACS'
*
        CALL BLACS_GRIDEXIT( CTXTI )
 1114 CONTINUE
*
*     
*
*        
*  ,        
*
   32   IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
          WRITE( NPR, FMT = 2007 ) NAME, N, NPRC, NBMIN, NBMAX
          WRITE( NPR, FMT = 2001 ) NPROWPRE, NPCOLPRE, NBPRE, TPRE
*       
*  ,        
*
         WRITE( NOUT1, FMT = 2007 ) NAME, N, NPRC, NBMIN, NBMAX
         WRITE( NOUT1, FMT = 2001 ) NPROWPRE, NPCOLPRE, NBPRE, TPRE
*
        END IF
*
*      
*          (N)
*   (NPRC).
*     NPROW, NPCOL, NB  
*     /-,    .
*
* File BSTDAT contains current date of executable module
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
*
         OPEN( NOUT, FILE = 'BSTDAT', STATUS = 'OLD' )
         READ( NOUT, FMT = * ) NLLB3
         CLOSE( NOUT )
*
         OPEN( NOUT, FILE = 'tmpfile', STATUS = 'UNKNOWN' )
         WRITE( NOUT, FMT = * ) N
         ENDFILE NOUT
         CLOSE( NOUT )
*
         OPEN( NOUT, FILE = 'tmpfile', STATUS = 'OLD' )
         READ( NOUT, FMT = * ) NLB
         CLOSE( NOUT )
*
         OPEN( NOUT, FILE = 'tmpfile', STATUS = 'OLD' )
         WRITE( NOUT, FMT = * ) NPRC
         ENDFILE NOUT
         CLOSE( NOUT )
*
         OPEN( NOUT, FILE = 'tmpfile', STATUS = 'OLD' )
         READ( NOUT, FMT = * ) NLLB1
         CLOSE( NOUT )
*
         DO 25 I = 7,1,-1
           IF( NLB(I:I) .EQ. ' ') GO TO 25
             K = I
             GO TO 29
   25    CONTINUE
*
   29    DO 27 I = 4,1,-1
           IF( NLLB1(I:I) .EQ. ' ') GO TO 27
             K1 = I
             GO TO 31
   27    CONTINUE
*
   31   NAM = NAME
*
         DO 28 I = 8,1,-1
           IF( NAM(I:I) .EQ. ' ') GO TO 28
             K2 = I
             GO TO 30
   28    CONTINUE
*
   30 NLLB2 =
     $NAM(2:K2)//'/_'//NLB(1:K)//'_'//NLLB1(1:K1)//'_'//NLLB3(1:6)
*
        K3 = K+K1+3+(K2-3+1)+7+(1)
*
        WRITE(NPR, FMT= *)NAM,NLB,NLLB1,NLLB2(1:K3),K,K1,K2,K3
*
         OPEN( NOUT, FILE = NLLB2(1:K3), STATUS = 'UNKNOWN' )
         WRITE( NOUT, FMT = 2011 )NPROWPRE, NPCOLPRE, NBPRE, TPRE
         CLOSE( NOUT )
*
* Close the file with all results of timing
*
         CLOSE( NOUT1 )
      END IF
*
* Exit out of BLACS
      CALL BLACS_EXIT( 0 )
*
   10 CONTINUE
*
 9995 FORMAT( A12 )
 2000 FORMAT( /A8,'  N = ',I5,'  NPROCS = ',I3/'   NPROW = ',I3,
     $       '  NPCOL = ',I3,'   NB = ',I3 )
 2001 FORMAT( 'Minimum time - for grid (',I3,','I3,
     $        ' )   NB = ', I3, D14.3/ )
 2011 FORMAT( I3,I3,I5/D11.3/ )
 2003 FORMAT( ' NPROW = ',I3,'  NPCOL = ',I3,'   NB = ', I3, D14.3/)
 2005 FORMAT(/'IAM1=',I5,I7,I3,I7,I3,'   CTXT=',I3,' J=',I3/)
 2007 FORMAT( /A8,'  N = ',I5,'   NPROCS = ',I3,'  NB(',I3,':',I3,')'/)
*
 9999 FORMAT( / ' The choice of the best parallelizing parameters ',
     $        ' for PARALGs programms '/ )
      RETURN
      END
*
